"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestValidationHandler = exports.isRequestValidationError = exports.Segments = exports.ValidateRequestError = exports.RequestValidationMiddleware = void 0;
var errors_1 = require("../errors");
;
var RequestValidationMiddleware = /** @class */ (function () {
    function RequestValidationMiddleware() {
    }
    ;
    RequestValidationMiddleware.getInstance = function () {
        if (!RequestValidationMiddleware._instance)
            RequestValidationMiddleware._instance = new RequestValidationMiddleware();
        return RequestValidationMiddleware._instance;
    };
    ;
    RequestValidationMiddleware.prototype.requestValidate = function (params) {
        return function (request, response, next) {
            var _a, _b, _c, _d, _e, _f;
            try {
                var err = new ValidateRequestError();
                if (params.body) {
                    var validate = (_a = params[Segments.BODY]) === null || _a === void 0 ? void 0 : _a.validate(request.body);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.BODY, validate.error);
                }
                ;
                if (params.cookies) {
                    var validate = (_b = params[Segments.COOKIES]) === null || _b === void 0 ? void 0 : _b.validate(request.cookies);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.COOKIES, validate.error);
                }
                ;
                if (params.headers) {
                    var validate = (_c = params[Segments.HEADERS]) === null || _c === void 0 ? void 0 : _c.validate(request.headers);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.HEADERS, validate.error);
                }
                ;
                if (params.params) {
                    var validate = (_d = params[Segments.PARAMS]) === null || _d === void 0 ? void 0 : _d.validate(request.params);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.PARAMS, validate.error);
                }
                ;
                if (params.query) {
                    var validate = (_e = params[Segments.QUERY]) === null || _e === void 0 ? void 0 : _e.validate(request.query);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.QUERY, validate.error);
                }
                ;
                if (params.signedCookies) {
                    var validate = (_f = params[Segments.SIGNEDCOOKIES]) === null || _f === void 0 ? void 0 : _f.validate(request.signedCookies);
                    if (validate === null || validate === void 0 ? void 0 : validate.error)
                        err.details.set(Segments.SIGNEDCOOKIES, validate.error);
                }
                ;
                if (err.details.size)
                    throw err;
                return next();
            }
            catch (error) {
                return next(error);
            }
            ;
        };
    };
    ;
    return RequestValidationMiddleware;
}());
exports.RequestValidationMiddleware = RequestValidationMiddleware;
;
var isRequestValidationError = function (err) {
    return err instanceof ValidateRequestError;
};
exports.isRequestValidationError = isRequestValidationError;
var requestValidationHandler = function (err, req, res, next) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (!isRequestValidationError(err)) {
                return [2 /*return*/, next(err)];
            }
            next(new errors_1.RequestValidationError(err));
            return [2 /*return*/];
        });
    });
};
exports.requestValidationHandler = requestValidationHandler;
var Segments;
(function (Segments) {
    Segments["BODY"] = "body";
    Segments["COOKIES"] = "cookies";
    Segments["HEADERS"] = "headers";
    Segments["PARAMS"] = "params";
    Segments["QUERY"] = "query";
    Segments["SIGNEDCOOKIES"] = "signedCookies";
})(Segments || (Segments = {}));
exports.Segments = Segments;
;
;
var ValidateRequestError = /** @class */ (function () {
    function ValidateRequestError() {
        this.details = new Map();
    }
    ;
    return ValidateRequestError;
}());
exports.ValidateRequestError = ValidateRequestError;
;
