import { Request, Response, NextFunction } from 'express';
declare function keycloakConfig(realm: string, authUrl: string, clientId: string, clientSecret: string, username: string, password: string): any;
interface UserPayload {
    sid: string;
    name: string;
    preferred_username: string;
    given_name: string;
    email: string;
    typ: 'Bearer';
    realm_access: object;
    resource_access: object;
}
interface CurrentUser {
    currentUser: UserPayload;
}
interface UserMiddleware {
    currentUser(req: Request, res: Response<any, CurrentUser>, next: NextFunction): Promise<void>;
}
declare class UserMiddleware {
    private static _instance;
    private constructor();
    static getInstance(): UserMiddleware;
}
export { keycloakConfig, UserPayload, CurrentUser, UserMiddleware };
