/// <reference types="node" />
import { S3 } from 'aws-sdk';
export interface BaseStorageService {
    getSignedURL(key: string, expires: string, objType: 'getObject' | 'putObject', contentType: string): Promise<string>;
    getPlainFileURL(fileURL: string): string;
    getObjectKey(fileURL: string): string;
    addObjectLock(key: string): Promise<any>;
    removeObjectLock(key: string): Promise<any>;
    getObject(key: string): Promise<ArrayBuffer>;
    putObject(key: string, body: Buffer): Promise<S3.PutObjectOutput>;
}
export declare abstract class BaseStorageService {
    private _s3StorageConnect;
    private _storage;
    private _nconf;
    constructor();
    abstract getFilePath(access: 'public' | 'private', fileSubType: 'avatar', fileType: 'user/avatar' | 'user/avatar-model', extension: string, userIdObj: Record<string, any> | null): string;
    abstract returnMimeType(fileURL: string): string;
    abstract returnExtension(mimeType: string): string;
    private _streamToString;
}
